;;; 
;;;       
;;;   
;;;
;;; () .   http://come.to/vodolaz,   2002
;;;


(load "3d.lsp")

;; ------------------------------   
;;                                    
;;
;;     
;; -  Fi-103 (  - -1)
;;
;;   -  -,  - 
;;    -  
;;
;;  - :       " "
;;
(setq example '((11.0 0.0 "1") (16.0 4.0 "2") (16.0 31.0 "3") (12.0 56.0 "4")
                (10.5 107.0 "5")
	)
)

;;    -1
(setq fau-1   '( (1.0 0 "F1") (3.0 6.0 "F2") (8.0 11.0 "F3") (14.0 18.0 "F4")
		 (19.0 30.0 "F5") (22.0 44.0 "F6") (24.0 59.0 "F7") (24.0 91.0 "F8")
		 (23.0 113.0 "F9") (21.0 136.5 "F10") (16.0 166.5 "F12") (11.0 188.5 "F13")
		 (1.0 212.5 "F14")
		)
      )

(setq fab250 '( (1.0 0 "F1")
	        (20.0 27.5 "F2")
	        (20.0 72.0 "F3")
	        (15.5 87.2 "F4")
	        (5.0 98.0 "F5")
	       )
      )


;;     ""
(setq kub-konus '(  (0.7 0 "F1") (7.5 19 "F2") (7.5 23.5 "F3")
	      (9.5 33.0 "F4")
	    )
      )

;;    ""
(setq kub-korpus '( (12.5 0 "K1") (13.0 3.5 "K2")
		    ( 14.5 11.0 "K4") (14.5 93.0 "K5") ( 14.5 128.0 "K6")
		   )
      )
;;;      
;;;   ,       ,
;;;   400 

(setq scale 32)            ;  Model-Art
;;   mnozh   ,      ,
;;       
;(setq mnozh (/ 400.0 (* scale (car (last example)))))
(setq mnozh (/ 487.39  29.0))

(print " - ") (prin1 mnozh)(terpri)

;;       
(setq zazor 5.0)
;;   
(setq polosa 2.0)
;;    
 (setq bumaga 0.2)


;;      
;;  ,   

(defun draw_circle ( center rad)
  ;;   
  (setq rad (* mnozh rad))
  ;;    
  (command "_layer" "S" "detail" "")
  (setq r (/ rad 2))
  (command "_circle" center  r)
  (setq x1 (car center)) (setq y (cadr center))
  (setq z (caddr center))
  (setq l (list (- x1 r 2) y z))
  (setq n (list x1 (+ y r 2) z))
  (setq rr (list (+ x1 r 2) y z)) 
  (setq s (list x1 (- y r 2) z))
  (command "_layer" "S" "center" "")
  (command "_line" l rr "" "_line" n s "")
)


;;     

(defun create_layers ()
  (command "_layer" "N" "detail" "C" "blue" "detail" "L" "continuous" "detail" "LW" "0.05" "detail" "")
  (command "_layer" "N" "center" "C" "green" "center" "L" "center" "center" "")
  (command "_layer" "N" "text" "C" "blue" "text" "L" "continuous" "text" "")

;;    ,   

;  (command "_limits" "0,0" "420,297")
;  (command "_grid" "5")
;  (command "_snap" "0.1")
  ;;  
  (command "_line" "20,5" "290,5" "290,205" "20,205" "_C" "")
  )


;;     

(defun get_cross ()
 (setq a (getreal "  : "))
 (setq b (getreal "    : "))
 (setq c (getstring "  : ")) 
 (list a b c)
)


;;
;;        
(defun draw_profile  ( p )
  (setq start (getpoint "     : "))
  (setq y (cadr start)) ;  
  (setq z (caddr start));  
  ;;    .    
  ;;   
  (setq xx1 (* mnozh (cadr (last p))))
  (setq xx2 (* mnozh (cadr (car p))))
  (setq end (list 
            (+ (- xx1 xx2) (car start))
               y z
             ))
  (princ "Start - ")(prin1 start)(terpri)
  (princ "End   - ")(prin1 end)(terpri)
    (command "_layer" "S" "center" "")
    (command "_line" start end "")
  ;;   
  ;; (car x) -   (cadr x) - 
  (mapcar (function ( lambda (x)
;;		      (princ "x = ")(prin1 x)(terpri)
            ;;  		      
            (setq xxx (list (* mnozh (car x))
			    (* mnozh (cadr x))
			    (caddr x)))
            (setq dy (/ (car xxx) 2))         		      
	   (setq from (list (+ (car start) (cadr xxx)) (- y dy) z))
	   (setq to    (list (car from) (+ y dy) z))
;;         (prin1 from)(princ " - ")(prin1 to)(terpri)
   	   (command "_layer" "S" "detail" "")
           (command "_line" from to "")
;;     
           (setq xx (list (+ (car from) 2) (+ y 1.5) z))
           (command "_layer" "S" "text" "")
           (command "_text" xx "1.5" "0" (caddr xxx))		      
	    ))
	 p)
  ;;      
     	   (command "_layer" "S" "detail" "")
  (setq st (list (car start) (+ (cadr start) (/ (* mnozh (cadr (car p))) 2)) z))
  (command "_line" st st "")
  ;;   ,    
  (mapcar (function (lambda (x)
	  (setq dy (/ (* mnozh (car x)) 2))	      
          (setq to (list (+ (car start) (* mnozh (cadr x))) (- y dy) z))
          (command "_line" "@" to "")		      

		      )) p)
  (command "_line" st st "")
  ;;   ,    
  (mapcar (function (lambda (x)
	  (setq dy (/ (* mnozh (car x)) 2))	      
          (setq to (list (+ (car start) (* mnozh (cadr x))) (+ y dy) z))
          (command "_line" "@" to "")		      

		      )) p)

  ) ;  

(defun dialog_collect ()
;;    
(setq profile '())
(while 
   (not (equal (car (setq prof (get_cross))) 0
    )   )
 ;  (prin1 prof)(terpri)     
   (setq profile (append profile (list prof)))
 ;  (prin1 profile)(terpri)
 profile
  ) ; while
)

;;; -------------------     


(defun plot_circles (p)

  (mapcar (function (lambda (xxx)
            (setq c (getpoint "   "))
            (draw_circle c (car xxx))		      
            ;;     
		(setq dy (/ (car xxx) 2)) (prin1 dy)  
		(setq xx (cadr c))
		(setq yy  (- xx 3 dy))
		     
            (setq podpis (list (car c) yy (caddr c)))
            (command "_layer" "S" "text" "")
            (command "_text" podpis "1.5" "0" (caddr xxx)) 		      
		      )) p)
  )

;;;      
;;;    
(defun xplus (arg shift)
  (list (+ (car arg) shift)
	 (cadr arg)
	 (caddr arg)
	 )
    )

(defun xminus (arg shift)
   (cons (- (car arg) shift)
	 (cdr arg)
	 )
  )

(defun yminus (arg shift)
    (list (car arg) (- (cadr arg) shift) (caddr arg))
  )

;;;    
(defun yplus (arg sh)
   (list (car arg)
	 (+ (cadr arg) sh)
	 (caddr arg)
	 )
  )

;;       
(defun xyplus (arg sh sh2)
  (yplus (xplus arg sh) sh2)
  )


;;;   

(defun plot_cylinder (start c1 c2)
   ;;   
  (setq height (* mnozh (- (cadr c2) (cadr c1)))) ;  
  (setq width  (* mnozh pi (car c1)))
;  (princ "  -  ")(prin1 height)(terpri)
;  (princ "  - ")(prin1 width)(terpri)

  (setq p2 (list (+ (car start) height) (cadr start) (caddr start)))
  (setq p3 (list (car p2) (+ (cadr start) width) (caddr start)))
  (setq p4 (list (car start) (cadr p3) (caddr start)))
  (command "_layer" "S" "detail" "")
  (command "_line"  start p2 p3 p4 "C" "")
  ;;       
  (setq p5 (list (car start) (+ (cadr start) (/ width 2)) (caddr start)))
  (setq p51 (list (+ (car p5) 1) (cadr p5) (caddr p5)))
  (setq p6 (list (car p2) (+ (cadr p2) (/ width 2)) (caddr start)))
  (setq p61 (list (- (car p6) 1) (cadr p6) (caddr p5)))
  (command "_layer" "S" "center" "")
  (command "_line"  p5 p51 "") (command "_line" p6 p61 "")
  ;;  
  (command "_layer" "S" "text" "")
  (command "_text" p2 "1.5" "0" (caddr c2))
  (command "_text" p4 "1.5" "0" (caddr c1))
  ;;    -   
  ;;        0.5  
  (setq klapan1 (yminus start  zazor))
  (setq klapan2 (yminus p2  zazor))
	
  (setq polosa1 (yminus klapan1 polosa)) 
  (setq polosa2 (yminus klapan2 polosa ))

   (setq klapan3 (yminus polosa1 polosa))
  (setq klapan4 (yminus polosa2 polosa))

  (princ "  - ")(prin1 klapan1)(princ " ")(prin1 klapan4)(terpri)
  (princ " - ")(prin1 polosa1)(princ " ")(prin1 polosa2)(terpri)
  
 (command "_layer" "_S" "center" "")
 (command "_line" polosa1 polosa2 "")
 
 (command "_layer" "_S" "detail" "")
  (command "_line" klapan1 klapan3 klapan4 klapan2 "_C" "" )
  
  
  )

;;;   

(defun plot_cone  (start c1 c2)
  (prin1 c1)(princ " - ")(prin1 c2)(terpri)
  ;;    
  (setq height (* mnozh (- (cadr c2) (cadr c1))))
  (princ "  - ")(prin1 height)(terpri)
  (if (> (car c1) (car c2))
    (progn
          (setq tmp c1) (setq c1 c2)
          (setq c2 tmp)
      ))
  ;;  
  (setq d1  (* mnozh (car c1)))
  (setq d2  (* mnozh (car c2)))
   ;;    
    (setq p1 (- d2 d1)) (setq p2 (* p1 p1))
    (setq koren (sqrt (+ (* 4 height height)
			 p2)))
    (setq rs (/ (* d1 koren)
		(* 2 p1)))
    (setq rb (/ (* d2 koren)
		(* 2 p1)))
    (setq alpha (/ (* 2 pi p1)
		   koren))
  (princ "  - ")(prin1 rs)(terpri)
  (princ "     - ")(prin1 rb)(terpri)
  (princ "      - ")(prin1 alpha)(terpri)
   ;;  ,   
   ;;      
   ;;
   ;;  ,    
  (setq dx (* rb (sin (/ alpha 2))))
  (setq dy (* rb (cos (/ alpha 2))))
  (setq verh (list (+ (car start) dx) (+ (cadr start) dy) (caddr start)))
  ;;     
  ;; ,      -  START -   
  (setq p4 (list (+ (car start) dx dx) (cadr start) (caddr start)))
  (setq p2 (list
	   (+ (car start) (- dx (* rs (sin (/ alpha 2)))))
	   (+ (cadr start) (- dy (* rs (cos (/ alpha 2)))))
	   (caddr start)
	 ))
  (setq p3 (list
	   (- (car p4) (- dx (* rs (sin (/ alpha 2)))))
           (cadr p2)
	   (caddr start)
	 ))
  ;; , ,  
  (command "_layer" "S" "detail" "")
  (command "_line" start p2 "")
  (command "_line" p3 p4 "")
  (command "_arc" "CE" verh p2 p3)
  (command "_arc" "CE" verh start p4)
  (command "_layer" "S" "text" "")
  (command "_text" p2 "1.5" "0" (caddr c1))
  (command "_text" p4 "1.5"  "0" (caddr c2))
  )


;;
;;    
;;
(defun simple_cone  (start c1 c2)
  (prin1 c1)(princ " - ")(prin1 c2)(terpri)
  ;;    
  (setq height (- (cadr c2) (cadr c1)))
  (princ "  - ")(prin1 height)(terpri)
  (if (> (car c1) (car c2))
    (progn
          (setq tmp c1) (setq c1 c2)
          (setq c2 tmp)
      ))
  ;;  
  (setq d1 (/ (car c2) 2)) (setq d2 (/ (car c1) 2))
  (setq l1 (* d1 pi)) (setq l2 (* d2 pi))
  ;; , ,  
  (setq p1 (list (- (car start) l1) (+ (cadr start) height) (caddr start)))
  (setq p2 (list (+ (car start) l1) (+ (cadr start) height) (caddr start)))
  (setq p3 (list (- (car start) l2) (cadr start) (caddr start)))
  (setq p4 (list (+ (car start) l2) (cadr start) (caddr start)))

  (command "_layer" "_S" "detail" "")
  (command "_line" p1 p2 p4 p3 "C" "")
  (command "_layer" "_S" "text" "")
  (command "_text" p2 "1.5" "0" (caddr c1))
  (command "_text" p4 "1.5"  "0" (caddr c2))
  )


;;;   ,   
;;;        
;;;    
;;;
;;;  c1 -   
;;;  2 -   
;;;
(defun plot_segment (c1 c2)
   (setq start (getpoint "   "))
   (cond
        ((eq (car c1) (car c2))
              (plot_cylinder start c1 c2))
	(t
	      (plot_cone start c1 c2))
	 )
     
  )

;; :      
;;      
(defun all_segments (p)
 (setq l  (length p))
  ;;     
  (setq i 0)
  (while (< i l)
      (plot_segment (nth i p) (nth (+ i 1) p))
      (setq i (+ i 1))
    )
  )



;;   ,    
;; base.       

(defun plot-3d-cone (base a b)
   (setq rad (/ (car a) 2))   ;  
   (setq top (/ (car b) 2))   ;  
   (setq height (- (cadr b) (cadr a)))      ;  
   (setq numseg 48)   
   (setq elev (caddr base)) ; Z -  
   (setvar "SURFTAB1" numseg)

  ; Draw base circle
  (command "_.CIRCLE" base rad)
  (setq undoit T)
  (setq e1 (entlast))
  (setq cen2 (list (car base) (cadr base) (+ (caddr base) height)))
  (setq oldelev (getvar "ELEVATION"))
  (command "_.ELEV" (+ elev height) "")
  (cond 
    ; Draw top point or circle
    ((= top 0.0) (command "_.POINT" cen2))  
    (t (command "_.CIRCLE" cen2 top))
  )
  (setq e2 (entlast))
  (setvar "ELEVATION" oldelev)
  
  (prin1 e1)(terpri)(prin1 e2)(terpri)
  
  ; Draw cone
  (command "_.RULESURF" (list e1 base) (list e2 cen2))
  (entdel e1) 
  (entdel e2)
  ;;    
  (setq base (list (car base) (cadr base) (+ (caddr base) height)))
)



;;;
;;;     
;;;

(defun 3dcigara (a)
  ;;     
  (setq base (getpoint "  ?"))
 
  (terpri)(princ "!   ")(terpri) 	
  (setq l (length a))
  (setq i 0)
  (while (< i (- l 1))
     (plot-3d-cone base (nth i a) (nth (+ i 1) a))
         (setq dlina (- (cadr (nth (+ i 1) a)) (cadr (nth i a))))
         (setq base (list (car base) (cadr base) (+ dlina (caddr base))))
     (setq i (+ i 1))
    )
  )


;;     

(defun all_draw (a)
  
(create_layers)
 
 (draw_profile a)
 (plot_circles a)
(all_segments a)
(command "_zoom" "A")
)


;;         
;;  
;;
;;  diam -   
;;  wid  -  
;;  point -  ,   
;;


(defun obkleika (diam wid point/ l)
   (setq l (* pi (+ diam bumaga bumaga))) ;  
   (command "_rectangle" point
	     (xyplus point wid l))
  )


;;         
;;  ,   
;;
;;  profile -    
;; tochka1  -   
;; tochka2  -       

(defun bomba-ugol (profile tochka1 tochka2 / l dlina)
  (setq l (length profile))   ;   
  (princ "  ")(prin1 l)(princ " ")(terpri)
  (setq el1 (nth  (- l 1) profile))
  (princ "  - ")(prin1 el1)(terpri)
  (setq el2 (nth  (- l 2) profile))
  (princ "  - ")(prin1 el2)(terpri)
  
  (setq rad1 (/ (car el2) 2)) ;   
  (setq rad2 (/ (car el1) 2)) ;  
  (setq dlina (- (cadr el1)    ;  
		 (cadr el2)
		 ))

  (setq drad (- rad1 rad2))    ; 

   (princ "  - ")(prin1 dlina)(terpri)
   (princ "       - ")(prin1 drad)(terpri)
    (setq ugol (angle '(0 0) (list dlina drad)))  ;    
    (princ "  - ") (prin1 ugol)(terpri)
  
     ;     ,  
     ;     tochka1    , 
     ;  Y    tochka2.      
     ; 

  (princ " ")(terpri)
    (setq tochka22 (yminus tochka2 50.0))
    (setq tochka21 (xyplus tochka1 (* 50.0 (cos ugol)) (* 50.0 (sin ugol))))

  (princ "  ")(terpri)
  (setq point (inters tochka1  tochka21  tochka2  tochka22  nil))
     ;    
  (command "_line" tochka1 point tochka2 "")
)
  


(defun startup (/ dcl_id)
  (if (< (setq dcl_id (Load_dialog "bombardir/start.dcl")) 0)
                (princ "   ")
		(exit))
  (prin1 dcl_id)(terpri)
  (if (not (new_dialog "bombardir" dcl_id)) (exit))
   (princ "2")
    (start_dialog)
    (unload_dialog dcl_id)
    (princ " \"\"  !")(terpri)
  
 )


; (startup)


; (3dcigara fab250)

(setq p1 (getpoint))
(setq p2 (getpoint))

(draw_profile fab250)

(bomba-ugol fab250 p1 p2)

;(command "_zoom" "A")

  